require "src/player"
require "src/objects"
require "src/teleporter"
require "src/chest"

function love.load()
    font = love.graphics.setNewFont(16)
    p = Player.new(0, 0)
    Map()
    love.window.setMode(1280 / 1.5, 780 / 1.5)
end

function love.update(dt)
    p:update(dt)
    
end

function love.draw()
    love.graphics.setColor(0,0.2,0.6, 0.2)
    love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
    love.graphics.setColor(1,1,1)
    love.graphics.push()
    if p.x > 0 then  
        love.graphics.translate(-p.x + love.graphics.getWidth() / 2, -p.y +  love.graphics.getHeight() / 2)
    elseif p.x < 0 then  
        love.graphics.translate(0 + love.graphics.getWidth() / 2, -p.y +  love.graphics.getHeight() / 2)
    end
    MapDraw()
    p:draw()
    love.graphics.pop()
end


function love.keypressed(key)
end
function debug()
    love.graphics.print("Player X:" .. p.x, p.x - p.w, p.y - p.h)
    love.graphics.print("Player Y:" .. p.y, p.x - p.w, p.y - p.h + 10)
    love.graphics.setColor(1, 0, 0)
    love.graphics.circle("line", p.x, p.y, 1)
    love.graphics.setColor(1, 1, 1)
end

function Map()
    blocks = {}
    map = {
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,},
        {0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,},
        {0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,},
        {1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,},
        {1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,},
        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,},
        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,},
        {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,},
    }
    tileSize = 32
    for y, xs in ipairs (map) do
        for x, value in ipairs (xs) do
            if value == 1 then
                b = Object.new((x-1)*50,(y-1)*50, 50, 50)
                table.insert(blocks, b)
            end
        end
    end
    
end

function MapDraw()
    for y, xs in ipairs (map) do
        for x, value in ipairs (xs) do
            if value == 1 then
                for i, b in ipairs(blocks) do 
                    b:draw()
                end
            end
        end
    end
end

--v is the value, m is the value that v should be the multiple of and dir says if v should be subtracted by one or if one should be added to it
function roundToMultiple(v, m, dir) 
    v=math.floor(v)
    while(v%m < 0 or v%m > 0) do 
        v = v + dir
    end
    return v
end

function collide(a, b)
    if a.x > b.x + b.w or b.x > a.x + a.w then 
        return false 
    end

    if a.y > b.y + b.w or b.y > a.y + a.h  then 
        return false 
    end
    print("collsion")
    return true
end

function aabb(a, b)
	return (a.x < b.x + b.w and a.x + a.w  > b.x and a.y < b.y + b.h and b.y < a.y + a.h)
end
