Teleporter = {}
Teleporter.__index = Teleporter

function Teleporter.new(x, y, w, h, destX, destY)
    local instance = setmetatable({}, Teleporter)
    instance.x = x 
    instance.y = y 
    instance.w = w
    instance.h = h
    instance.destX = destX 
    instance.destY = destY 
    instance.body = love.physics.newBody(world, instance.x, instance.y, "static")
    instance.shape = love.physics.newRectangleShape(instance.w, instance.h)
    instance.fixture =love.physics.newFixture(instance.body, instance.shape)
    instance.body:setFixedRotation(true)
    return instance
end

function Teleporter:update()
    if todo == true then
        p.body:setTransform(self.destX, self.destY, 0)
        todo = false
    end
end

function Teleporter:draw()
    love.graphics.rectangle("fill", self.x - self.w / 2, self.y - self.h / 2, self.w, self.h)
end

function Teleporter:beginCon(a, b, collision)
    if a == self.fixture and b == p.fixture or b == self.fixture and a == p.fixture then 
        todo = true
    end
end